/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/9/19
 * To change this template use File | Settings | File Templates.
 */
import cp from  "./els";
cp.extend(cp.fn, {
    html: function (html) {
        return arguments.length === 0 ?
            (this.length > 0 ? this[0].innerHTML : null) :
            this.each(function () {
                this.innerHTML = html;
            })
    },
    text: function (text) {
        return arguments.length === 0 ?
            (this.length > 0 ? this[0].textContent : null) :
            this.each(function () {
                this.textContent = (text === undefined) ? '' : '' + text
            })
    },
    attr: function (name, value) {
        var result, key
        return (typeof name == 'string' && value === undefined) ?
            (this.length == 0 || this[0].nodeType !== 1 ? undefined :
                    (name == 'value' && this[0].nodeName == 'INPUT') ? this.val() :
                        (!(result = this[0].getAttribute(name)) && name in this[0]) ? this[0][name] : result
            ) :
            this.each(function () {
                if (this.nodeType !== 1) return;
                if (cp.isObject(name)) for (key in name) this.setAttribute(key, name[key]);
                else  this.setAttribute(name, value);
            })
    },
    removeAttr: function (name) {
        return this.each(function () {
            this.nodeType === 1 && this.removeAttr(name)
        })
    },
    val: function (value) {
        return arguments.length === 0 ?
            (this[0] && (this[0].multiple ? Array.prototype.slice.call(this[0].options).map(function (opt) {
                        if (opt.selected) return opt.value;
                    }).join(',') : this[0].value)
            ) : this.each(function () {
                this.value = value
            })
    }
})