const gulp = require('gulp');
const babel = require('gulp-babel');
const uglify = require('gulp-uglify');

// 编译并压缩js
gulp.task('convertJS',  function () {
    return gulp.src(`src/*.js`)
        .pipe(babel({
            presets: ['es2015']
        }))
        .pipe(uglify({
            compress: true,
            mangle: {reserved: ['require', 'exports', 'module', '$']},
            output: {
                ascii_only: true
            }
        }))
        .pipe(gulp.dest('lib/'));
})

gulp.task('product', ['convertJS'], function () {
    console.log(`~~~~~~~~~~~~~gulp---src----end~~~~~~~~~~`);
});
