/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/9/11
 * To change this template use File | Settings | File Templates.
 */
/**
 * Created with IntelliJ IDEA.
 * By: jozhua@live.cn
 * Time: 2017/3/2 12:41
 * To change this template use File | Settings | File Templates.
 */

function select(e) {
    var t;
    if ("SELECT" === e.nodeName)
        e.focus(), t = e.value;
    else if ("INPUT" === e.nodeName || "TEXTAREA" === e.nodeName) {
        var n = e.hasAttribute("readonly");
        n || e.setAttribute("readonly", "");
        e.select();
        e.setSelectionRange(0, e.value.length);
        n || e.removeAttribute("readonly");
        t = e.value
    } else {
        e.hasAttribute("contenteditable") && e.focus();
        var o = window.getSelection(), i = document.createRange();
        i.selectNodeContents(e);
        o.removeAllRanges();
        o.addRange(i);
        t = o.toString()
    }
    return t;
}

/*
 复制到剪切板
 支持但用户体验不太好：  IE6/7/8/9/10/11/   会弹窗询问用户是否允许网页访问系统剪切板
 由于安全性的原因，safari不支持，可以在error回调中作出相应的处理（例如选中文本，让用户直接复制，而不用先长按选中再复制）
 */
function copy(text, callback) {
    var status = false, fn = function (status) {
        if (!status) {
            status = window.prompt('请手动全选以下文字，并剪切或拷贝。', text);
            status = '' == status || text == status;
        }
        callback && callback(status);
    };
    // 如果是IE，就使用IE专有方式进行拷贝
    if (window.clipboardData) {
        status = window.clipboardData.setData('Text', text);
        fn(status)
    } else {
        var textArea = document.createElement('textarea');
        var styleArr = ['font-size:12pt;', 'position:absolute;', 'padding: 0', 'margin: 0', 'left:-1000px;'];
        textArea.style.cssText = styleArr.join('');
        textArea.setAttribute('readonly', '');
        textArea.style.top = (window.pageYOffset || document.documentElement.scrollTop) + 'px';
        textArea.value = text;
        document.body.appendChild(textArea);
        select(textArea);
        try {
            status = document.execCommand('copy');
        } catch (e) {
            status = false;
        }
        fn(status);
        setTimeout(function () {
            window.getSelection().removeAllRanges();
            document.body.removeChild(textArea);
        }, 100)
    }
}

function support() {
    var t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : ["copy", "cut"]
        , n = "string" == typeof t ? [t] : t
        , o = !!document.queryCommandSupported;
    return n.forEach(function (e) {
        o = o && !!document.queryCommandSupported(e)
    }), o;
}
export default {
    bind: function (el, msg, callback) {
        if (typeof msg === 'function') {
            callback = msg;
            msg = el.getAttribute('data-copy') || '';
        }
        if (msg) {
            el.addEventListener('click', function () {
                copy(msg, callback);
            })
        }
    },
    copy: copy,
    support: support
}