/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/9/15
 * To change this template use File | Settings | File Templates.
 */
import cp from './els';
cp.fn.serializeArray = function () {
    var name, type, result = [],
        add = function (value) {
            if (value.forEach) return value.forEach(add)
            result.push({name: name, value: value})
        };
    if (this[0]) cp.each(this[0].elements, function (_, field) {
        type = field.type, name = field.name
        if (name && field.nodeName.toLowerCase() != 'fieldset' && !field.disabled && type != 'submit' && type != 'reset' && type != 'button' && type != 'file' && ((type != 'radio' && type != 'checkbox') || field.checked)){
            if (field.multiple) {
                add(Array.prototype.slice.call(field.options).map(function (opt) {
                    if (opt.selected) return opt.value;
                }))
            }
            else add(field.value)
        }
    });
    return result
}
cp.fn.serialize = function () {
    var result = [];
    this.serializeArray().forEach(function (elm) {
        result.push(encodeURIComponent(elm.name) + '=' + encodeURIComponent(elm.value))
    });
    return result.join('&')
}

cp.fn.submit = function (callback) {
    if (0 in arguments) this.on('submit', callback);
    else if (this.length) {
        var event = cp.events('submit');
        this.eq(0).trigger(event);
        if (!event.isDefaultPrevented()) this.get(0).submit()
    }
    return this
}