/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/7/18
 * To change this template use File | Settings | File Templates.
 */
import style from './stylesheets';
var Loader = function (config) {
    this.$body = document.body;
    var div = document.createElement('div');
    div.innerHTML = '<div class="loading-pox"><svg viewBox="0 0 150 150" id="svg"><g class="circle"><circle cx="75" cy="75" r="70"></circle><circle cx="75" cy="75" r="70" class="rotation" stroke="' + config.fill + '"></circle></g>' + config.txt + '</svg></div>';
    div.style.background = 'rgba(12, 12, 12, 0.2)';
    div.style.visibility = 'hidden';
    div.className = 'pop-layout';
    this.$body.appendChild(div);
    this.$div = div;
    this.$pop = div.getElementsByClassName('loading-pox')[0];
    this.insertCssRule()
}
Loader.prototype.insertCssRule = function () {
    var $load = this.$pop, css ='.loading-pox{display:block;visibility:hidden;width:1.4rem;height:1.4rem;background-color:rgba(255,255,255,0.9);padding:.12rem;border-radius:.2rem;-webkit-border-radius:.2rem;box-sizing:content-box;-webkit-box-sizing:border-box}@keyframes spin{0%{transform:rotate(0);stroke-dashoffset:45} 50%{transform:rotate(720deg);stroke-dashoffset:400} 100%{transform:rotate(1080deg);stroke-dashoffset:45}}@-webkit-keyframes spin{0%{-webkit-transform:rotate(0);stroke-dashoffset:45} 50%{-webkit-transform:rotate(720deg);stroke-dashoffset:400} 100%{-webkit-transform:rotate(1080deg);stroke-dashoffset:45}}svg{display:block;width:100%;height:100%}.circle circle{fill:rgba(255,255,255,0);stroke-width:4}.circle circle:first-child{stroke:#e9e9e9}.circle circle:last-child{stroke-dasharray:471;transform-origin:50% 50% 0;-webkit-transform-origin:50% 50% 0;stroke-dashoffset:45;animation:spin 3s linear infinite;-webkit-animation:spin 3s linear infinite}.pop-layout{-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;display:-webkit-box;display:-ms-flexbox;display:-webkit-flex;display:flex;-webkit-box-pack:center;-webkit-justify-content:center;justify-content:center;-webkit-box-align:center;-webkit-align-items:center;align-items:center;bottom:0;left:0;position:absolute;right:0;top:0;z-index:10700}';
    setTimeout(function () {
        var currentStyle = style.getCurrentStyle($load);
        if (currentStyle.visibility != 'hidden') style.importStyle(css);
    }, 100)
}
Loader.prototype.open = function () {
    this.$div.style.visibility = '';
    this.$pop.style.visibility = 'visible';
    return this;
}
Loader.prototype.close = function () {
    var self = this;
    this.$div.style.display = 'none';
    if (self.$div) {
        setTimeout(function () {
            self.$body.removeChild(self.$div);
            self.$div = null;
        })
    }
    return this;
}
export default Loader;