/**
 * Created with IntelliJ IDEA.
 * @author: jozhua@live.cn
 * @date: 2017/6/2
 * To change this template use File | Settings | File Templates.
 */
import './event';
import './tap';
import './class';
import './dom';
import './fix';
import style from './stylesheets';
import cp from './els';

let cache = {zIndex: 11111, dialogs: {}}, $ = cp.el, prev = function (e) {
    e.preventDefault();
}, ev = cp.support.touchEvent, ios = /(iPhone|iPad|iPod)/.test(navigator.userAgent), popCss = ".pop-overlay{position:absolute;left:0;top:0;width:100%;height:100%;background-color:rgba(0,0,0,0.2);opacity:0;z-index:10600;visibility:hidden;-webkit-transition-duration:400ms;transition-duration:400ms;-webkit-transition-property:-webkit-transform,opacity;transition-property:transform,opacity}.pop-overlay.pop-overlay-visible{visibility:visible;opacity:1}.pop-layout{-webkit-box-sizing:border-box;box-sizing:border-box;display:-webkit-box;display:-webkit-flex;display:flex;-webkit-box-pack:center;-webkit-justify-content:center;justify-content:center;-webkit-box-align:center;-webkit-align-items:center;align-items:center;bottom:0;left:0;position:absolute;right:0;top:0;z-index:10700}.pop-dialogs{width:5.4rem;overflow:hidden;border-radius:.14rem;-webkit-border-radius:.14rem;visibility:hidden}.pop-dialogs.pop-animate{visibility:visible;opacity:0;-webkit-transform:translate3d(0,0,0) scale(1.185);transform:translate3d(0,0,0) scale(1.185);-webkit-transition-property:-webkit-transform,opacity;transition-property:transform,opacity}.pop-dialogs.pop-auto-width{width:auto!important}.pop-dialogs.pop-in{visibility:visible;opacity:1;-webkit-transition-duration:400ms;transition-duration:400ms;-webkit-transform:translate3d(0,0,0) scale(1);transform:translate3d(0,0,0) scale(1)}.pop-dialogs.pop-out{opacity:0;-webkit-transition-duration:400ms;transition-duration:400ms;-webkit-transform:translate3d(0,0,0) scale(0.815);transform:translate3d(0,0,0) scale(0.815)}.pop-dialogs .pop-inner{padding:.3rem;border-radius:.14rem .14rem 0 0;position:relative;background:#f8f8f8}.pop-dialogs .pop-inner:after{content:'';position:absolute;left:0;bottom:0;right:auto;top:auto;height:1px;width:100%;background-color:#b5b5b5;display:block;z-index:15;-webkit-transform-origin:50% 100%;transform-origin:50% 100%}[data-dpr='2'] .pop-dialogs .pop-inner:after{-webkit-transform:scaleY(0.5);transform:scaleY(0.5)}[data-dpr='3'] .pop-dialogs .pop-inner:after{-webkit-transform:scaleY(0.33);transform:scaleY(0.33)}.pop-dialogs .pop-hd{font-weight:700;font-size:18px;text-align:center;margin-bottom:.16rem;border-radius:.06rem .06rem 0 0}.pop-dialogs .pop-bd{min-height:.6rem;overflow:hidden}.pop-dialogs .pop-ft{height:.88rem;overflow:hidden;display:-webkit-box;display:-webkit-flex;display:flex;-webkit-box-pack:center;-webkit-justify-content:center;justify-content:center}.pop-dialogs .pop-btn{width:100%;padding:0 .1rem;height:.88rem;font-size:15px;line-height:.88rem;text-align:center;color:#007aff;background:#f8f8f8;display:block;position:relative;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;cursor:pointer;-webkit-box-sizing:border-box;box-sizing:border-box;-webkit-box-flex:1;box-flex:1;-webkit-flex:1;flex:1}.pop-dialogs .pop-btn:after{content:'';position:absolute;right:0;top:0;left:auto;bottom:auto;width:1px;height:100%;background-color:#b5b5b5;display:block;z-index:15;-webkit-transform-origin:100% 50%;transform-origin:100% 50%}[data-dpr=\"2\"] .pop-dialogs .pop-btn:after{-webkit-transform:scaleX(0.5);transform:scaleX(0.5)}[data-dpr=\"3\"] .pop-dialogs .pop-btn:after{-webkit-transform:scaleX(0.33);transform:scaleX(0.33)}.pop-dialogs .pop-btn:first-child{border-radius:0 0 0 .14rem}.pop-dialogs .pop-btn:first-child:last-child{border-radius:0 0 .14rem .14rem}.pop-dialogs .pop-btn:last-child{border-radius:0 0 .14rem 0}.pop-dialogs .pop-btn:last-child:after{display:none}.pop-dialogs .pop-btn.pop-btn-bold{font-weight:700}.pop-dialogs .pop-btn:active,.pop-dialogs .pop-btn.active-state{background:#d4d4d4}.pop-dialogs .pop-close{top:0;right:0;position:absolute;display:block;padding:.12rem}.pop-dialogs .pop-msg{font-size:14px;line-height:1.5;text-align:center;word-break:break-all}.pop-dialogs.pop-no-btns .pop-inner{border-radius:.14rem}.pop-dialogs.pop-no-btns .pop-inner:after{display:none}.pop-dialogs.pop-no-btns .pop-btns{display:none}.pop-toast{background:#3e3e3e;-webkit-box-shadow:0 0 8px #626262;box-shadow:0 0 8px #626262}.pop-toast .pop-inner{background:#4c4c4c;box-shadow:none;padding:.1rem}.pop-toast .pop-msg{color:#fff;line-height:2}@media screen and (max-width:321px) and (orientation:portrait){.pop-dialogs .pop-hd{font-size:17px}.pop-dialogs .pop-btn{font-size:14px}.pop-dialogs .pop-msg{font-size:13px}}@media screen and (min-width:400px) and (orientation:portrait){.pop-dialogs .pop-hd{font-size:.36rem}.pop-dialogs .pop-btn{font-size:.29rem}.pop-dialogs .pop-msg{font-size:.28rem}}[data-landscape=\"1\"] .pop-dialogs .pop-hd{font-size:.34rem}[data-landscape=\"1\"] .pop-dialogs .pop-btn{font-size:.28rem}[data-landscape=\"1\"] .pop-dialogs .pop-msg{font-size:.26rem}", initCss = !1;

function getScollTop(el) {
    return 'scrollTop' in el ? el.scrollTop : el.pageYOffset
}
function importStyle(e) {
    var div = document.createElement('div'), body = document.body, currentStyle;
    div.className = 'pop-overlay';
    body.appendChild(div);
    setTimeout(function () {
        currentStyle = style.getCurrentStyle(div);
        if (currentStyle.visibility != 'hidden' || currentStyle.opacity != '0') style.importStyle(e);
        body.removeChild(div);
    }, 10)
}
//pop
let pop = function (opts) {
    //默认参数
    let defOpts = {
        /**
         * 是否加载CSS
         */
        initCss: false,
        /**
         * 弹出框标题
         * @property {String} [title=null]
         */
        title: null,
        /**
         * 额外样式
         * @property {String} [cls=null]
         */
        cls: null,     //额外样式
        /**
         * 宽度
         * @property {String} [width=24rem]
         */
        width: "",     //自定义宽度
        /**
         * 高度
         * @property {String} [height=auto]
         */
        height: "auto",     //自定义高度
        /**
         * 是否显示关闭按钮
         * @property {Boolean} [isClose=true]
         */
        isClose: true,
        /**
         * 是否在弹出的时候禁用scroll
         * @property {Boolean} [scrollMove=false]
         */
        scrollMove: false,
        /**
         * 弹出框内容
         * @property {String} [con=null]
         */
        con: '',
        /**
         * 弹出框上的按钮
         * @property {Array} [btns=[{txt : '关闭', fn : 'close'}]]
         */
        btns: [{           //按钮
            txt: '关闭',
            fn: 'close'
        }],
        /**
         * 弹出框显示完后的回调函数
         * @type {function}
         */
        onShow: function () {
        },
        /**
         * 弹出框关闭后的回调函数
         * @type {function}
         */
        onClose: function () {
        },
        /**
         * 自动关闭
         * @type {int}
         */
        timeout: 0
    };
    this.opts = cp.extend(defOpts, opts);
    if (!initCss) {
        importStyle(popCss);
        initCss = !0;
    }
    this.init();
};
pop.prototype = {
    init  () { //初始化
        let _ts = this,
            opts = this.opts;
        //基础属性
        _ts.id = opts.id || 'dialog-' + uuid();    //自动设置id
        _ts.body = document.body;             //body
        _ts.win = $(window);                    //window
        _ts.tkey = false;
        _ts.render();   //渲染
    },
    renderBtn (btns, _ts) {//渲染按钮
        let btnHtml = '',
            len = btns.length > 2 ? 2 : btns.length,  //最多显示2个按钮
            close = function () {
                _ts.remove();
            };
        if (len > 0) {
            for (let i = 0, l = len; i < l; i++) {
                let ret = btns[i];
                if (typeof ret === 'object' && typeof ret.txt !== 'undefined') {
                    //按钮
                    let btn = '';
                    if (typeof ret.href !== 'undefined') {
                        btn = '<span class="pop-btn" data-i="' + i + '"><a href="' + ret.href + '">' + ret.txt + '</a></span>';
                    } else {
                        btn = '<span class="pop-btn" data-i="' + i + '">' + ret.txt + '</span>';
                    }
                    btnHtml += btn;
                    //回调方法
                    btns[i].fn = (typeof btns[i].fn !== 'undefined' && btns[i].fn === 'close') ? close : btns[i].fn;
                }
            }
            return '<div class="pop-ft">' + btnHtml + '</div>';
        } else {
            return '';
        }
    },
    render () { //渲染
        let _ts = this,
            opts = _ts.opts,
            titleEl = opts.title ? '<div class="pop-hd">' + opts.title + '</div>' : '',
            btnsEl = _ts.renderBtn(opts.btns, _ts),
            conEl = '',
            cls = opts.cls ? opts.cls : '',
            popLayout = document.createElement('div'),
            popOver = document.createElement('div'),
            pop;
        if (opts.btns == null || opts.btns.length < 1) cls += ' pop-no-btns';
        popOver.style.zIndex = getZindex();
        popOver.className = 'pop-overlay';
        popLayout.className = 'pop-layout';
        popLayout.style.zIndex = getZindex();
        popLayout.id = _ts.id;
        if (typeof opts.msg !== 'undefined') {
            conEl = '<div class="pop-msg">' + opts.msg + '</div>';
        } else if (opts.con) {
            if (cp.isFunction(opts.con)) { //fun
                conEl = opts.con(_ts);
            } else { //string
                conEl = opts.con;
            }
        }
        popLayout.innerHTML = '<div class="pop-dialogs ' + cls + '"><div class="pop-inner">' + titleEl + '<div class="pop-bd">' + conEl + '</div></div>' + btnsEl + '</div>';
        _ts.body.appendChild(popOver);
        _ts.body.appendChild(popLayout);

        pop = popLayout.getElementsByClassName('pop-dialogs');
        if (pop.length) pop = pop[0];
        _ts._isRemove = false;
        _ts.pop = $(pop);
        _ts.popOver = $(popOver);
        _ts.popLayout = $(popLayout);

        opts.height && (pop.style.height = opts.height);
        opts.width && (pop.style.width = opts.width);
        if (opts.width == 'auto') pop.className = pop.className + ' pop-auto-width';
        _ts.open();
    }, bind () { //绑定事件
        let _ts = this, opts = _ts.opts;
        //执行onShow
        opts.onShow && opts.onShow.call(_ts, _ts.pop);

        let btns = opts.btns, events = {
            'touchend': function (e) {
                e.preventDefault();
            }
        };
        events[ev] = function () {
            let i = this.getAttribute('data-i');
            if (cp.isFunction(btns[i].fn)) {
                btns[i].fn.call(_ts, _ts.pop, $(this));
            }
            return false;
        };
        _ts.pop.on(events, '.pop-ft span');
        //close
        if (opts.isClose) {
            events[ev] = function () {
                _ts.remove();
            }
            _ts.pop.on(events, '.pop-close');
        }
        //    _ts.pop.on(ev, 'a', $.proxy(this.remove, _ts));
        //旋转屏幕
        _ts.win.on('ortchange resize', function () {
            _ts.refresh();
        });
        opts.scrollMove && _ts.win.on('touchmove', prev)
    },
    open () {
        var _ts = this, opts = _ts.opts;
        _ts._isOpen = true;

        //显示
        _ts.popOver.addClass('pop-overlay-visible');
        //定位
        _ts.refresh();
        _ts.pop.addClass('pop-animate');

        setTimeout(function () {
            _ts.pop.removeClass('pop-out').addClass('pop-in').transitionEnd(function () {
                _ts.pop.removeClass('pop-animate');
            });
        }, 30);
        if (!_ts._isRemove) {    //绑定事件  防止点击按钮瞬间的点透问题，故做了400ms延迟
            setTimeout(function () {
                _ts.bind();
            }, 400);
            //检查是否定时关闭
            opts.timeout && setTimeout(function () {
                _ts.remove();
            }, opts.timeout);
        }
        cache.dialogs[_ts.id] = _ts;
    },
    refresh () {
        var _ts = this, ret, action;
        if (_ts._isOpen) {
            var win = _ts.win[0], scrollTop = getScollTop(win), flag;
            action = function () {
                ret = _ts._calculate();
                if (ret.mask) {
                    _ts.popOver[0].style.width = '100%';
                    _ts.popOver[0].style.height = ret + 'px';
                }
                if (!flag) setTimeout(function () {
                    if (getScollTop(win) != scrollTop && (flag = true)) action();
                }, 200)
            }
            if (ios &&
                document.activeElement &&
                /input|textarea|select/i.test(document.activeElement.tagName)) {
                _ts.body.scrollLeft = 0;
                document.activeElement.blur();
                setTimeout(function () {
                    action();
                }, 300);
            } else {
                action();//do it now
            }
        }
        return _ts;
    },
    _calculate  () {
        let root = this.body;
        return this.popOver ? Math.max(root.scrollHeight, root.clientHeight) - 0 : 0;//不减1的话uc浏览器再旋转的时候不触发resize.奇葩！;
    }, remove () {
        var _ts = this, dialogs = cache.dialogs;
        if (_ts.id && dialogs[_ts.id]) {
            //执行onClose
            if (cp.isFunction(_ts.opts.onClose)) {
                _ts.opts.onClose.call(_ts, _ts.pop);
            }
            _ts._isOpen = false;
            _ts._isRemove = true;
            _ts.close();
            _ts.opts.scrollMove && _ts.win.off('touchmove', prev);
            dialogs[_ts.id] = null;
            delete dialogs[_ts.id];
            _ts = null;
        }
    }, close () {
        this.popOver.removeClass('pop-overlay-visible');
        this.pop.removeClass('pop-in').addClass('pop-out').transitionEnd(() => {
            this.pop.removeClass('pop-out');
            this.popLayout.remove();
            this.popOver.remove();
        })
    },
    removeAll () {
        removeAll();
    }
}

function uuid() {
    let S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return (S4() + "-" + S4());
}
function getZindex() {
    return cache['zIndex']++;
}
function removeAll() {
    let dialogs = cache.dialogs;
    for (let d in dialogs)dialogs[d].remove();
}
let noop = function () {
}, dialog, slice = Array.prototype.slice, isFun = cp.isFunction;
let popfn = function (opts) {
    return new pop(opts);
}, defaultOpts = {
    title: null,
    cls: null,
    width: "",
    height: "auto",
    isClose: false,
    btns: ['取消', '好']
}, getWidth = function () {
    var dpr = window.flex && flex.dpr > 1 ? flex.dpr : 1, cw = document.body.getBoundingClientRect().width;
    cw = Math.floor(cw * 0.72);
    return Math.min(cw, dpr * 540) + 'px';
}
cp.extend(cp, dialog = {
    removePops: removeAll,
    alert (txt, callback) {
        let opts = cp.extend({}, defaultOpts);
        opts.msg = txt;
        if (typeof callback == 'object') {
            opts = cp.extend(opts, callback);
            callback = callback['callback'];
        }
        callback = isFun(callback) ? callback : noop;
        let btns = opts['btn'] || [];
        opts.btns = [{
            txt: btns[0] || defaultOpts['btns'][1],
            fn: function () {
                callback.apply(this, slice.call(arguments, 0)) !== false && this.remove();
            }
        }];
        if (!opts.width) opts.width = getWidth();
        return popfn(opts);
    },
    confirm (txt, callback) {
        var opts = cp.extend({}, defaultOpts);
        opts.msg = txt;
        if (typeof callback == 'object') {
            opts = cp.extend(opts, callback);
            callback = opts['callback'];
        }
        callback = isFun(callback) ? callback : noop;
        var btns = opts['btn'] || [];
        opts.btns = [{
            txt: btns[0] || defaultOpts['btns'][0],
            fn: function () {
                this.remove();
            }
        }, {
            txt: btns[1] || defaultOpts['btns'][1],
            fn: function () {
                callback.apply(this, slice.call(arguments, 0)) !== false && this.remove();
            }
        }];
        if (!opts.width) opts.width = getWidth();
        return popfn(opts)
    },
    toast (txt, timeout, callback) {
        if (isFun(timeout)) {
            callback = timeout;
            timeout = 0;
        }
        callback = isFun(callback) ? callback : noop;
        return popfn({
            isClose: false,
            cls: 'pop-toast',
            btns: [],
            timeout: +timeout || 2000,
            msg: txt,
            width: getWidth(),
            onClose: function () {
                callback.apply(this, slice.call(arguments, 0)) === false && this.remove();
            }
        });
    }, pop (opts) {
        return popfn(opts);
    }, setDef (obj) {
        defaultOpts = cp.extend(defaultOpts, obj || {})
    }
});
export {dialog as pop}